#include "main.h"
#include "coremark.h"
#define CORE_DEBUG 1
#define USER_DEBUG 1

volatile u32 SysTickFlag = 0; // ʼÿ1ms1

bit busy;

void sys_init();
void UartSendStr(char *p);
void Uart1_Init(void);

void main()
{
    sys_init();

    coremark_main();
    
    while(1) {
        
    }
}

void Timer0_Isr(void) interrupt 1
{
    SysTickFlag++;
}

void Timer0_Init(void)		//1@24.000MHz
{
    AUXR |= 0x80;			//ʱʱ1Tģʽ
    TMOD &= 0xF0;			//öʱģʽ
    TL0 = 0x40;				//öʱʼֵ
    TH0 = 0xA2;				//öʱʼֵ
    TF0 = 0;				//TF0־
    TR0 = 1;				//ʱ0ʼʱ
    ET0 = 1;				//ʹܶʱ0ж
}

void Uart1_Init(void)	//9600bps@24.000MHz
{
    P_SW1 |=0x40;
    P3M0 |= 0x80; P3M1 &= ~0x80; 

    SCON = 0x50;		//8λ,ɱ䲨
    AUXR |= 0x40;		//ʱʱ1Tģʽ
    AUXR &= 0xFE;		//1ѡʱ1Ϊʷ
    TMOD &= 0x0F;		//öʱģʽ
    TL1 = 0x8F;			//öʱʼֵ
    TH1 = 0xFD;			//öʱʼֵ
    ET1 = 0;			//ֹʱж
    TR1 = 1;			//ʱ1ʼʱ
    busy = 0;
}


void UartSend(char dat)
{
    while (busy);
    busy = 1;
    SBUF = dat;
}

void UartSendStr(char *p)
{
    while (*p)
    {
        UartSend(*p++);
    }
}

void Uart1_Isr(void) interrupt 4
{
	if (TI)				//⴮1ж
	{
		TI = 0;			//1жλ
        busy = 0;
	}
	if (RI)				//⴮1ж
	{
		RI = 0;			//1жλ
	}
}

void sys_init() {

    EAXFR = 1;
    WTST = 0X00;
    CKCON = 0X00;

    Timer0_Init();
    Uart1_Init();
    
    ES = 1;
    EA = 1;
    

}